var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
import React, { isValidElement, useContext } from "react";
import classnames from "classnames";
import Icon from "../icon";
import Loading from "../loading";
import { BORDER_SURROUND, WHITE } from "../utils/constant";
import ConfigProviderContext from "../config-provider/ConfigProviderContext";
const Button = (props) => {
  const {
    tag,
    type,
    color,
    plain,
    disabled,
    loading,
    hairline,
    className,
    iconPrefix,
    loadingText,
    iconPosition
  } = props;
  const {
    prefixCls,
    createNamespace
  } = useContext(ConfigProviderContext);
  const [bem] = createNamespace("button", prefixCls);
  const classes = classnames(className, bem([type, props.size, {
    plain,
    loading,
    disabled,
    hairline,
    block: props.block,
    round: props.round,
    square: props.square,
    shadow: props.shadow,
    [`shadow-${+props.shadow}`]: props.shadow
  }]), {
    [BORDER_SURROUND]: hairline
  });
  const style = __spreadValues({}, props.style);
  if (color) {
    style.color = plain ? color : WHITE;
    if (!plain) {
      style.background = color;
    }
    if (color.indexOf("gradient") !== -1) {
      style.border = 0;
    } else {
      style.borderColor = color;
    }
  }
  function onClick(event) {
    if (!loading && !disabled && props.onClick) {
      props.onClick(event);
    }
  }
  const renderLoadingIcon = () => {
    const {
      loadingSize = "20px",
      loadingType
    } = props;
    return /* @__PURE__ */ React.createElement(Loading, {
      className: classnames(bem("loading")),
      size: loadingSize,
      type: loadingType,
      color: type === "default" ? void 0 : ""
    });
  };
  const renderIcon = () => {
    if (props.loading) {
      return renderLoadingIcon();
    }
    if (typeof props.icon === "string") {
      return /* @__PURE__ */ React.createElement(Icon, {
        name: props.icon,
        className: classnames(bem("icon")),
        classPrefix: iconPrefix
      });
    }
    if (/* @__PURE__ */ isValidElement(props.icon)) {
      return props.icon;
    }
    return null;
  };
  const renderText = () => {
    let text;
    if (loading) {
      text = loadingText;
    } else {
      text = props.children || props.text;
    }
    if (text) {
      return /* @__PURE__ */ React.createElement("span", {
        key: "text",
        className: classnames(bem("text"))
      }, text);
    }
    return null;
  };
  const renderContent = () => /* @__PURE__ */ React.createElement("div", {
    className: classnames(bem("content"))
  }, iconPosition === "left" && renderIcon(), renderText(), iconPosition === "right" && renderIcon());
  return /* @__PURE__ */ React.createElement(tag, {
    style,
    className: classes,
    type: props.nativeType,
    disabled,
    onClick
  }, renderContent());
};
Button.defaultProps = {
  size: "normal",
  type: "default",
  tag: "button",
  iconPosition: "left"
};
var stdin_default = Button;
export {
  stdin_default as default
};
