var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import React, { forwardRef, useContext, useImperativeHandle, useMemo } from "react";
import Checker from "./Checker";
import CheckBoxContext from "./CheckboxContext";
import useMergedState from "../hooks/use-merged-state";
import ConfigProviderContext from "../config-provider/ConfigProviderContext";
const CheckBox = /* @__PURE__ */ forwardRef((props, ref) => {
  const {
    prefixCls,
    createNamespace
  } = useContext(ConfigProviderContext);
  const [bem] = createNamespace("checkbox", prefixCls);
  const _a = useContext(CheckBoxContext), {
    parent
  } = _a, context = __objRest(_a, [
    "parent"
  ]);
  const [checked, setChecked] = useMergedState({
    value: props.checked,
    defaultValue: props.defaultChecked
  });
  const setParentValue = (isChecked2) => {
    const {
      name
    } = props;
    const {
      max
    } = parent.props;
    const value = context.checked.slice();
    if (isChecked2) {
      const overlimit = max && value.length >= +max;
      if (!overlimit && value.indexOf(name) === -1) {
        value.push(name);
        if (props.bindGroup) {
          context.toggle(value);
        }
      }
    } else {
      const index = value.indexOf(name);
      if (index !== -1) {
        value.splice(index, 1);
        if (props.bindGroup) {
          context.toggle(value);
        }
      }
    }
  };
  const isChecked = useMemo(() => {
    if (parent && props.bindGroup) {
      return context.checked.indexOf(props.name) !== -1;
    }
    return checked;
  }, [context.checked, checked]);
  const toggle = (newValue = !isChecked) => {
    var _a2;
    if (parent && props.bindGroup) {
      setParentValue(newValue);
    } else {
      setChecked(newValue);
      (_a2 = props.onChange) == null ? void 0 : _a2.call(props, newValue);
    }
  };
  useImperativeHandle(ref, () => ({
    toggle,
    checked: isChecked,
    props
  }));
  return /* @__PURE__ */ React.createElement(Checker, _extends({}, props, {
    bem,
    role: "checkbox",
    parent,
    checked: isChecked,
    className: props.className,
    bindGroup: props.bindGroup,
    onToggle: toggle
  }));
});
CheckBox.displayName = "Checkbox";
CheckBox.defaultProps = {
  bindGroup: true
};
var stdin_default = CheckBox;
export {
  stdin_default as default
};
