var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import React, { useMemo } from "react";
import ConfigProviderContext, { INITIAL_STATE } from "./ConfigProviderContext";
function kebabCase(str) {
  return str.replace(/([A-Z])/g, "-$1").toLowerCase().replace(/^-/, "");
}
function mapThemeVarsToCSSVars(themeVars) {
  const cssVars = {};
  Object.keys(themeVars).forEach((key) => {
    cssVars[`--rc-${kebabCase(key)}`] = themeVars[key];
  });
  return cssVars;
}
const ConfigProvider = (_a) => {
  var _b = _a, {
    className,
    style,
    themeVars,
    tag,
    children
  } = _b, props = __objRest(_b, [
    "className",
    "style",
    "themeVars",
    "tag",
    "children"
  ]);
  const varStyle = useMemo(() => {
    if (themeVars) {
      return __spreadValues(__spreadValues({}, style), mapThemeVarsToCSSVars(themeVars));
    }
    return style;
  }, [themeVars]);
  return /* @__PURE__ */ React.createElement(ConfigProviderContext.Provider, {
    value: __spreadValues(__spreadValues({}, INITIAL_STATE), props)
  }, /* @__PURE__ */ React.createElement(tag, {
    className,
    style: varStyle
  }, children));
};
ConfigProvider.defaultProps = {
  tag: "div"
};
var stdin_default = ConfigProvider;
export {
  stdin_default as default
};
