var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import React, { useEffect, useState } from "react";
import { noop } from "../utils";
import BaseDialog from "./Dialog";
import { resolveContainer } from "../utils/dom/getContainer";
import { unmount, render } from "../utils/dom/render";
const Dialog = BaseDialog;
Dialog.show = (props) => {
  const defaultOptions = {
    overlay: true,
    closeable: false,
    closeIcon: "cross",
    lockScroll: true,
    transition: "rc-dialog-bounce",
    showConfirmButton: true,
    showCancelButton: false,
    closeOnClickOverlay: false
  };
  const _a = props, {
    onClosed,
    onCancel = noop,
    onConfirm = noop,
    onClose = noop,
    cancelProps,
    confirmProps
  } = _a, restProps = __objRest(_a, [
    "onClosed",
    "onCancel",
    "onConfirm",
    "onClose",
    "cancelProps",
    "confirmProps"
  ]);
  const userContainer = resolveContainer(props.teleport);
  const container = document.createElement("div");
  userContainer.appendChild(container);
  let destroy = noop;
  const TempDialog = () => {
    const [visible, setVisible] = useState(false);
    const [cancelLoading, setCancelLoading] = useState(false);
    const [okLoading, setOkLoading] = useState(false);
    useEffect(() => {
      setVisible(true);
    }, []);
    destroy = () => {
      setVisible(false);
      if (onClose)
        onClose();
    };
    const _afterClose = () => {
      if (onClosed) {
        onClosed();
      }
      const unmountResult = unmount(container);
      if (unmountResult && container.parentNode) {
        container.parentNode.removeChild(container);
      }
    };
    const _onConfirm = (e) => __async(void 0, null, function* () {
      const i = setTimeout(() => setOkLoading(true));
      if ((yield onConfirm(e)) !== false) {
        clearTimeout(i);
        destroy();
      } else {
        clearTimeout(i);
        setOkLoading(false);
      }
    });
    const _onCancel = (e, clickOverlay) => __async(void 0, null, function* () {
      if (clickOverlay) {
        destroy();
        return;
      }
      const i = setTimeout(() => setCancelLoading(true));
      if ((yield onCancel(e)) !== false) {
        clearTimeout(i);
        destroy();
      } else {
        clearTimeout(i);
        setCancelLoading(false);
      }
    });
    return /* @__PURE__ */ React.createElement(BaseDialog, _extends({}, defaultOptions, restProps, {
      visible,
      teleport: () => container,
      cancelProps: __spreadValues({
        loading: cancelLoading
      }, cancelProps),
      confirmProps: __spreadValues({
        loading: okLoading
      }, confirmProps),
      onClose: destroy,
      onCancel: _onCancel,
      onConfirm: _onConfirm,
      onClosed: _afterClose
    }));
  };
  render(/* @__PURE__ */ React.createElement(TempDialog, null), container);
  return destroy;
};
Dialog.alert = (props) => {
  const {
    onConfirm = noop
  } = props;
  return new Promise((resolve) => {
    Dialog.show(__spreadProps(__spreadValues({}, props), {
      onConfirm: (e) => {
        onConfirm(e);
        resolve(e);
      }
    }));
  });
};
Dialog.confirm = (props) => {
  const {
    onCancel = noop,
    onConfirm = noop
  } = props;
  return new Promise((resolve, reject) => {
    Dialog.show(__spreadProps(__spreadValues({
      // 强制显示 OK Btn
      confirmButtonText: "\u786E\u8BA4",
      showCancelButton: true
    }, props), {
      onCancel: (e) => {
        onCancel(e);
        reject();
      },
      onConfirm: (e) => {
        onConfirm(e);
        resolve(true);
      }
    }));
  });
};
var stdin_default = Dialog;
export {
  stdin_default as default
};
