var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import React, { useContext, useMemo } from "react";
import classnames from "classnames";
import { addUnit } from "../utils";
import { BORDER } from "../utils/constant";
import Badge from "../badge";
import Icon from "../icon";
import ConfigProviderContext from "../config-provider/ConfigProviderContext";
const GridItem = (_a) => {
  var _b = _a, {
    children,
    className,
    style
  } = _b, props = __objRest(_b, [
    "children",
    "className",
    "style"
  ]);
  const {
    prefixCls,
    createNamespace
  } = useContext(ConfigProviderContext);
  const [bem] = createNamespace("grid-item", prefixCls);
  const {
    index,
    parent
  } = props;
  if (!parent) {
    if (process.env.NODE_ENV !== "production") {
      console.error("[rc-ui-lib] <GridItem> must be a child component of <Grid>.");
    }
  }
  const rootStyle = useMemo(() => {
    const {
      square: square2,
      gutter: gutter2,
      columnNum
    } = parent;
    const percent = `${100 / +columnNum}%`;
    const internalStyle = __spreadProps(__spreadValues({}, style), {
      flexBasis: percent
    });
    if (square2) {
      internalStyle.paddingTop = percent;
    } else if (gutter2) {
      const gutterValue = addUnit(gutter2);
      internalStyle.paddingRight = gutterValue;
      if (index >= columnNum) {
        internalStyle.marginTop = gutterValue;
      }
    }
    return internalStyle;
  }, [parent.style, parent.gutter, parent.columnNum]);
  const contentStyle = useMemo(() => {
    const {
      square: square2,
      gutter: gutter2
    } = parent;
    if (square2 && gutter2) {
      const gutterValue = addUnit(gutter2);
      return __spreadProps(__spreadValues({}, props.contentStyle), {
        right: gutterValue,
        bottom: gutterValue,
        height: "auto"
      });
    }
    return props.contentStyle;
  }, [parent.gutter, parent.columnNum, props.contentStyle]);
  const renderIcon = () => {
    if (typeof props.icon === "string") {
      return /* @__PURE__ */ React.createElement(Icon, {
        badge: props.badge,
        name: props.icon,
        size: parent.iconSize,
        className: classnames(bem("icon")),
        classPrefix: props.iconPrefix,
        color: props.iconColor
      });
    }
    if (/* @__PURE__ */ React.isValidElement(props.icon)) {
      return /* @__PURE__ */ React.createElement(Badge, props.badge, props.icon);
    }
    return null;
  };
  const renderText = () => {
    if (/* @__PURE__ */ React.isValidElement(props.text)) {
      return props.text;
    }
    if (props.text) {
      return /* @__PURE__ */ React.createElement("span", {
        className: classnames(bem("text"))
      }, props.text);
    }
    return null;
  };
  const renderContent = () => {
    if (children) {
      return children;
    }
    return /* @__PURE__ */ React.createElement(React.Fragment, null, renderIcon(), renderText());
  };
  const {
    center,
    border,
    square,
    gutter,
    reverse,
    direction
  } = parent;
  const classes = classnames(props.contentClassName, bem("content", [direction, {
    center,
    square,
    reverse,
    clickable: !!props.onClick,
    surround: border && gutter
  }]), {
    [BORDER]: border
  });
  return /* @__PURE__ */ React.createElement("div", {
    className: classnames(className, bem({
      square
    })),
    style: rootStyle
  }, /* @__PURE__ */ React.createElement("div", {
    role: props.onClick ? "button" : void 0,
    className: classes,
    style: contentStyle,
    onClick: props.onClick
  }, renderContent()));
};
GridItem.defaultProps = {
  index: 0,
  parent: {}
};
var stdin_default = GridItem;
export {
  stdin_default as default
};
