var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import React, { useEffect, useContext, createElement } from "react";
import classNames from "classnames";
import { addCssClassName, DEFAULT_EVENTS, DEFAULT_URL, loadImage, setImage } from "./utils";
import useEventVisible from "./utils/useEventVisible";
import ConfigProviderContext from "../config-provider/ConfigProviderContext";
const LazyloadImage = (props) => {
  const {
    prefixCls,
    createNamespace
  } = useContext(ConfigProviderContext);
  const [bem] = createNamespace("lazyload-image", prefixCls);
  const _a = props, {
    className,
    type,
    style: incomingStyle,
    image,
    errorImage,
    loading,
    eventOptions,
    height,
    width,
    onLoaded
  } = _a, restProps = __objRest(_a, [
    "className",
    "type",
    "style",
    "image",
    "errorImage",
    "loading",
    "eventOptions",
    "height",
    "width",
    "onLoaded"
  ]);
  const [containerRef, visible] = useEventVisible(eventOptions);
  useEffect(() => {
    if (visible && containerRef.current) {
      const target = containerRef.current;
      const url = target.dataset.src || "";
      loadImage(url).catch(() => {
        setImage(target, errorImage);
        addCssClassName(target, bem("error"));
      }).then((imagePath) => {
        setImage(target, imagePath);
        addCssClassName(target, bem("loaded"));
        target.setAttribute("lazy", "loaded");
        target.removeAttribute("data-src");
        onLoaded == null ? void 0 : onLoaded();
      });
    }
  }, [visible]);
  const style = __spreadProps(__spreadValues({}, incomingStyle), {
    height,
    width
  });
  return /* @__PURE__ */ React.createElement(React.Fragment, null, type === "image" ? /* @__PURE__ */ createElement("img", __spreadProps(__spreadValues({}, restProps), {
    ref: containerRef,
    style,
    "data-src": image,
    src: loading || DEFAULT_URL,
    className: classNames(bem(), className)
  })) : /* @__PURE__ */ createElement("div", __spreadProps(__spreadValues({}, restProps), {
    ref: containerRef,
    style,
    "data-src": image,
    className: classNames(bem(), className)
  }), props.children));
};
LazyloadImage.defaultProps = {
  loading: null,
  eventOptions: {
    listenEvents: DEFAULT_EVENTS,
    scrollContainer: document.body,
    offset: 0,
    debounce: 300,
    throttle: 0
  },
  type: "image",
  errorImage: DEFAULT_URL
};
var stdin_default = LazyloadImage;
export {
  stdin_default as default
};
