var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import React, { memo, useContext } from "react";
import classnames from "classnames";
import ConfigProviderContext from "../config-provider/ConfigProviderContext";
const PageIndicator = /* @__PURE__ */ memo((_a) => {
  var _b = _a, {
    color = "primary",
    direction = "horizontal"
  } = _b, props = __objRest(_b, [
    "color",
    "direction"
  ]);
  const {
    prefixCls,
    createNamespace
  } = useContext(ConfigProviderContext);
  const [bem] = createNamespace("indicator", prefixCls);
  const isVertical = direction === "vertical";
  const dots = [];
  for (let i = 0; i < props.total; i++) {
    dots.push(/* @__PURE__ */ React.createElement("div", {
      key: i,
      className: classnames(bem("dot", {
        active: props.current === i
      }))
    }));
  }
  return /* @__PURE__ */ React.createElement("div", {
    className: classnames(props.className, bem({
      vertical: isVertical
    })),
    style: __spreadValues({
      color
    }, props.style)
  }, dots);
});
export {
  PageIndicator
};
