var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import React, { useContext, useMemo } from "react";
import classnames from "classnames";
import TabbarContext from "./TabbarContext";
import { Icon } from "../icon";
import { Badge } from "../badge";
import ConfigProviderContext from "../config-provider/ConfigProviderContext";
const TabbarItem = (props) => {
  const {
    setActive,
    index
  } = props;
  const {
    prefixCls,
    createNamespace
  } = useContext(ConfigProviderContext);
  const [bem] = createNamespace("tabbar-item", prefixCls);
  const {
    parent
  } = useContext(TabbarContext);
  const {
    activeColor,
    inactiveColor
  } = parent;
  if (!parent) {
    if (process.env.NODE_ENV !== "production") {
      console.error("[rc-ui-lib] <TabbarItem> must be a child component of <Tabbar>.");
    }
  }
  const active = useMemo(() => {
    return (props.name || index) === parent.value;
  }, [props.name, index, parent.value]);
  const onClick = (event) => {
    var _a, _b;
    setActive((_a = props.name) != null ? _a : index);
    (_b = props.onClick) == null ? void 0 : _b.call(props, event);
  };
  const renderIcon = () => {
    if (typeof props.icon === "string") {
      return /* @__PURE__ */ React.createElement(Icon, {
        name: props.icon,
        classPrefix: props.iconPrefix
      });
    }
    if (typeof props.icon === "function") {
      return props.icon(active);
    }
    return null;
  };
  const color = active ? activeColor : inactiveColor;
  return /* @__PURE__ */ React.createElement("div", {
    className: classnames(props.className, bem({
      active
    })),
    style: __spreadProps(__spreadValues({}, props.style), {
      color
    }),
    onClick
  }, /* @__PURE__ */ React.createElement(Badge, _extends({}, props.badge, {
    className: classnames(bem("icon"))
  }), renderIcon()), /* @__PURE__ */ React.createElement("div", {
    className: classnames(bem("text"))
  }, typeof props.children === "function" ? props.children(active) : props.children));
};
var stdin_default = TabbarItem;
export {
  stdin_default as default
};
