var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_utils = require("../utils");
var import_number = require("../utils/validate/number");
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const Badge = (props) => {
  const {
    content,
    max,
    dot,
    showZero,
    tag
  } = props;
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("badge", prefixCls);
  const hasContent = () => {
    return (0, import_utils.isDef)(content) && content !== "" && (showZero || +content !== 0);
  };
  const renderContent = () => {
    if (!dot && hasContent()) {
      if ((0, import_utils.isDef)(max) && (0, import_number.isNumeric)(content == null ? void 0 : content.toString()) && +content > +max) {
        return `${max}+`;
      }
      return content;
    }
    return null;
  };
  const getOffsetWithMinusString = (val) => val.startsWith("-") ? val.replace("-", "") : `-${val}`;
  const renderBadge = () => {
    if (hasContent() || props.dot) {
      let style = {
        background: props.color
      };
      if (props.offset) {
        const [x, y] = props.offset;
        const {
          position
        } = props;
        const [offsetY, offsetX] = position.split("-");
        if (props.children) {
          if (typeof y === "number") {
            style[offsetY] = (0, import_utils.addUnit)(offsetY === "top" ? y : -y);
          } else {
            style[offsetY] = offsetY === "top" ? (0, import_utils.addUnit)(y) : getOffsetWithMinusString(y);
          }
          if (typeof x === "number") {
            style[offsetX] = (0, import_utils.addUnit)(offsetX === "left" ? x : -x);
          } else {
            style[offsetX] = offsetX === "left" ? (0, import_utils.addUnit)(x) : getOffsetWithMinusString(x);
          }
        } else {
          style.marginTop = (0, import_utils.addUnit)(y);
          style.marginLeft = (0, import_utils.addUnit)(x);
        }
      }
      if (!props.children) {
        style = __spreadValues(__spreadValues({}, props.style), style);
      }
      return /* @__PURE__ */ import_react.default.createElement("div", {
        className: (0, import_classnames.default)({
          [props.className]: props.className && !props.children
        }, bem([props.position, {
          dot: props.dot,
          fixed: !!props.children
        }])),
        style
      }, renderContent());
    }
    return null;
  };
  if (props.children) {
    return /* @__PURE__ */ import_react.default.createElement(tag, {
      className: (0, import_classnames.default)(bem("wrapper"), props.className),
      onClick: props.onClick,
      onTouchStart: props.onTouchStart,
      style: props.style
    }, props.children, renderBadge());
  }
  return renderBadge();
};
Badge.defaultProps = {
  tag: "div",
  showZero: true,
  position: "top-right"
};
var stdin_default = Badge;
