var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_icon = __toESM(require("../icon"));
var import_loading = __toESM(require("../loading"));
var import_constant = require("../utils/constant");
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const Button = (props) => {
  const {
    tag,
    type,
    color,
    plain,
    disabled,
    loading,
    hairline,
    className,
    iconPrefix,
    loadingText,
    iconPosition
  } = props;
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("button", prefixCls);
  const classes = (0, import_classnames.default)(className, bem([type, props.size, {
    plain,
    loading,
    disabled,
    hairline,
    block: props.block,
    round: props.round,
    square: props.square,
    shadow: props.shadow,
    [`shadow-${+props.shadow}`]: props.shadow
  }]), {
    [import_constant.BORDER_SURROUND]: hairline
  });
  const style = __spreadValues({}, props.style);
  if (color) {
    style.color = plain ? color : import_constant.WHITE;
    if (!plain) {
      style.background = color;
    }
    if (color.indexOf("gradient") !== -1) {
      style.border = 0;
    } else {
      style.borderColor = color;
    }
  }
  function onClick(event) {
    if (!loading && !disabled && props.onClick) {
      props.onClick(event);
    }
  }
  const renderLoadingIcon = () => {
    const {
      loadingSize = "20px",
      loadingType
    } = props;
    return /* @__PURE__ */ import_react.default.createElement(import_loading.default, {
      className: (0, import_classnames.default)(bem("loading")),
      size: loadingSize,
      type: loadingType,
      color: type === "default" ? void 0 : ""
    });
  };
  const renderIcon = () => {
    if (props.loading) {
      return renderLoadingIcon();
    }
    if (typeof props.icon === "string") {
      return /* @__PURE__ */ import_react.default.createElement(import_icon.default, {
        name: props.icon,
        className: (0, import_classnames.default)(bem("icon")),
        classPrefix: iconPrefix
      });
    }
    if (/* @__PURE__ */ (0, import_react.isValidElement)(props.icon)) {
      return props.icon;
    }
    return null;
  };
  const renderText = () => {
    let text;
    if (loading) {
      text = loadingText;
    } else {
      text = props.children || props.text;
    }
    if (text) {
      return /* @__PURE__ */ import_react.default.createElement("span", {
        key: "text",
        className: (0, import_classnames.default)(bem("text"))
      }, text);
    }
    return null;
  };
  const renderContent = () => /* @__PURE__ */ import_react.default.createElement("div", {
    className: (0, import_classnames.default)(bem("content"))
  }, iconPosition === "left" && renderIcon(), renderText(), iconPosition === "right" && renderIcon());
  return /* @__PURE__ */ import_react.default.createElement(tag, {
    style,
    className: classes,
    type: props.nativeType,
    disabled,
    onClick
  }, renderContent());
};
Button.defaultProps = {
  size: "normal",
  type: "default",
  tag: "button",
  iconPosition: "left"
};
var stdin_default = Button;
