var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const CalendarDay = (props) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("calendar", prefixCls);
  const {
    item,
    index,
    color,
    offset,
    rowHeight
  } = props;
  const calcStyle = (0, import_react.useMemo)(() => {
    const style = {
      height: rowHeight
    };
    if (item.type === "placeholder") {
      style.width = "100%";
      return style;
    }
    if (index === 0) {
      style.marginLeft = `${100 * offset / 7}%`;
    }
    if (color) {
      switch (item.type) {
        case "end":
        case "start":
        case "start-end":
        case "multiple-middle":
        case "multiple-selected":
          style.background = color;
          break;
        case "middle":
          style.color = color;
          break;
        default:
          break;
      }
    }
    return style;
  }, [item, index, color, offset, rowHeight]);
  const onClick = () => {
    var _a;
    if (props.item.type !== "disabled") {
      (_a = props.onClick) == null ? void 0 : _a.call(props, item);
    }
  };
  const renderTopInfo = () => {
    const {
      topInfo
    } = props.item;
    return topInfo || props.topInfoRender ? /* @__PURE__ */ import_react.default.createElement("div", {
      key: String(index),
      className: (0, import_classnames.default)(bem("top-info"))
    }, props.topInfoRender ? props.topInfoRender(props.item) : topInfo) : null;
  };
  const renderBottomInfo = () => {
    const {
      bottomInfo
    } = props.item;
    return bottomInfo || props.bottomInfoRender ? /* @__PURE__ */ import_react.default.createElement("div", {
      key: String(index),
      className: (0, import_classnames.default)(bem("bottom-info"))
    }, props.bottomInfoRender ? props.bottomInfoRender(props.item) : bottomInfo) : null;
  };
  const renderContent = () => {
    const {
      type: type2,
      text
    } = item;
    const Nodes = [renderTopInfo(), text, renderBottomInfo()];
    if (type2 === "selected") {
      return /* @__PURE__ */ import_react.default.createElement("div", {
        className: (0, import_classnames.default)(bem("selected-day")),
        style: {
          width: rowHeight,
          height: rowHeight,
          background: color
        }
      }, Nodes);
    }
    return Nodes;
  };
  const {
    type,
    className
  } = props.item;
  return type === "placeholder" ? /* @__PURE__ */ import_react.default.createElement("div", {
    key: String(index),
    className: (0, import_classnames.default)(bem("day")),
    style: calcStyle
  }) : /* @__PURE__ */ import_react.default.createElement("div", {
    role: "gridcell",
    style: calcStyle,
    className: (0, import_classnames.default)(bem("day", type), className),
    tabIndex: type === "disabled" ? void 0 : -1,
    onClick
  }, renderContent());
};
CalendarDay.defaultProps = {
  offset: 0
};
var stdin_default = CalendarDay;
