var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_icon = __toESM(require("../icon"));
var import_utils = require("../utils");
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const Cell = (props) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("cell", prefixCls);
  const renderLabel = () => {
    const showLabel = (0, import_utils.isDef)(props.label);
    if (showLabel) {
      return /* @__PURE__ */ import_react.default.createElement("div", {
        className: (0, import_classnames.default)(bem("label"), props.labelClass)
      }, props.label);
    }
    return null;
  };
  const renderTitle = () => {
    if ((0, import_utils.isDef)(props.title)) {
      return /* @__PURE__ */ import_react.default.createElement("div", {
        className: (0, import_classnames.default)(bem("title"), props.titleClass),
        style: props.titleStyle
      }, props.title, renderLabel());
    }
    return null;
  };
  const renderValue = () => {
    const hasTitle = (0, import_utils.isDef)(props.title);
    const hasValue = props.children || (0, import_utils.isDef)(props.value);
    if (hasValue) {
      return /* @__PURE__ */ import_react.default.createElement("div", {
        className: (0, import_classnames.default)(bem("value", {
          alone: !hasTitle
        }), props.valueClass)
      }, props.children ? props.children : /* @__PURE__ */ import_react.default.createElement("span", null, props.value));
    }
    return null;
  };
  const renderLeftIcon = () => {
    if (typeof props.icon === "string") {
      return /* @__PURE__ */ import_react.default.createElement(import_icon.default, {
        name: props.icon,
        className: (0, import_classnames.default)(bem("left-icon")),
        classPrefix: props.iconPrefix
      });
    }
    if (/* @__PURE__ */ (0, import_react.isValidElement)(props.icon)) {
      return props.icon;
    }
    return null;
  };
  const renderRightIcon = () => {
    if (props.rightIcon) {
      return props.rightIcon;
    }
    if (props.isLink) {
      const name = props.arrowDirection ? `arrow-${props.arrowDirection}` : "arrow";
      return /* @__PURE__ */ import_react.default.createElement(import_icon.default, {
        name,
        className: (0, import_classnames.default)(bem("right-icon"))
      });
    }
    return null;
  };
  const {
    className,
    style,
    size,
    center,
    border = true,
    isLink,
    required,
    onClick
  } = props;
  const clickable = isLink || props.clickable;
  const classes = {
    center,
    required,
    clickable,
    borderless: !border
  };
  if (size) {
    classes[size] = !!size;
  }
  return /* @__PURE__ */ import_react.default.createElement("div", {
    style,
    className: (0, import_classnames.default)(bem(classes), className),
    role: clickable ? "button" : void 0,
    onClick
  }, renderLeftIcon(), renderTitle(), renderValue(), renderRightIcon(), props.extra);
};
var stdin_default = Cell;
