var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_CollapseContext = __toESM(require("./CollapseContext"));
var import_constant = require("../utils/constant");
var import_hooks = require("../hooks");
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
function validateModelValue(modelValue, accordion) {
  if (accordion && Array.isArray(modelValue)) {
    console.error('[rc-ui-lib] Collapse: "value" should not be Array in accordion mode');
    return false;
  }
  if (!accordion && !Array.isArray(modelValue)) {
    console.error('[rc-ui-lib] Collapse: "value" should be Array in non-accordion mode');
    return false;
  }
  return true;
}
const Collapse = (props) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("collapse", prefixCls);
  const innerEffect = (0, import_react.useRef)(false);
  const [modelValue, setModelValue] = (0, import_react.useState)(() => {
    var _a;
    return (_a = props.value) != null ? _a : props.initValue;
  });
  const updateName = (name) => {
    var _a;
    innerEffect.current = true;
    setModelValue(name);
    (_a = props.onChange) == null ? void 0 : _a.call(props, name);
  };
  const toggle = (name, isExpanded2) => {
    const {
      accordion
    } = props;
    if (accordion) {
      updateName(name === modelValue ? "" : name);
    } else if (isExpanded2) {
      updateName(modelValue.concat(name));
    } else {
      updateName(modelValue.filter((activeName) => activeName !== name));
    }
  };
  const isExpanded = (name) => {
    const {
      accordion
    } = props;
    if (process.env.NODE_ENV !== "production" && !validateModelValue(modelValue, accordion)) {
      return false;
    }
    return accordion ? modelValue === name : modelValue.includes(name);
  };
  (0, import_hooks.useUpdateEffect)(() => {
    if (innerEffect.current) {
      innerEffect.current = false;
      return;
    }
    setModelValue(props.value);
  }, [props.value]);
  return /* @__PURE__ */ import_react.default.createElement(import_CollapseContext.default.Provider, {
    value: {
      isExpanded,
      toggle
    }
  }, /* @__PURE__ */ import_react.default.createElement("div", {
    className: (0, import_classnames.default)(bem(), {
      [import_constant.BORDER_TOP_BOTTOM]: props.border
    })
  }, import_react.default.Children.toArray(props.children).filter(Boolean).map((child, index) => /* @__PURE__ */ import_react.default.cloneElement(child, {
    index
  }))));
};
Collapse.defaultProps = {
  border: true,
  initValue: []
};
var stdin_default = Collapse;
