var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
var import_utils = require("./utils");
var import_use_count_down = require("../hooks/use-count-down");
const CountDown = /* @__PURE__ */ (0, import_react.forwardRef)((props, ref) => {
  const {
    time,
    format,
    autoStart,
    millisecond,
    renderChildren
  } = props;
  const {
    start,
    pause,
    reset,
    current
  } = (0, import_use_count_down.useCountDown)({
    time: +time,
    millisecond,
    onChange: (value) => {
      var _a;
      return (_a = props.onChange) == null ? void 0 : _a.call(props, value);
    },
    onFinish: props.onFinish
  });
  const timeText = (0, import_react.useMemo)(() => (0, import_utils.parseFormat)(format, current), [format, current]);
  const resetTime = () => {
    reset(+time);
    if (autoStart) {
      start();
    }
  };
  (0, import_react.useEffect)(() => {
    resetTime();
  }, [time]);
  (0, import_react.useImperativeHandle)(ref, () => ({
    start,
    pause,
    reset: resetTime
  }));
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("count-down", prefixCls);
  return /* @__PURE__ */ import_react.default.createElement("div", {
    role: "timer",
    className: (0, import_classnames.default)(bem())
  }, renderChildren ? renderChildren(current) : timeText);
});
CountDown.defaultProps = {
  time: 0,
  format: "HH:mm:ss",
  autoStart: true,
  millisecond: false
};
var stdin_default = CountDown;
