var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_utils = require("../utils");
var import_constant = require("../utils/constant");
var import_badge = __toESM(require("../badge"));
var import_icon = __toESM(require("../icon"));
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const GridItem = (_a) => {
  var _b = _a, {
    children,
    className,
    style
  } = _b, props = __objRest(_b, [
    "children",
    "className",
    "style"
  ]);
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("grid-item", prefixCls);
  const {
    index,
    parent
  } = props;
  if (!parent) {
    if (process.env.NODE_ENV !== "production") {
      console.error("[rc-ui-lib] <GridItem> must be a child component of <Grid>.");
    }
  }
  const rootStyle = (0, import_react.useMemo)(() => {
    const {
      square: square2,
      gutter: gutter2,
      columnNum
    } = parent;
    const percent = `${100 / +columnNum}%`;
    const internalStyle = __spreadProps(__spreadValues({}, style), {
      flexBasis: percent
    });
    if (square2) {
      internalStyle.paddingTop = percent;
    } else if (gutter2) {
      const gutterValue = (0, import_utils.addUnit)(gutter2);
      internalStyle.paddingRight = gutterValue;
      if (index >= columnNum) {
        internalStyle.marginTop = gutterValue;
      }
    }
    return internalStyle;
  }, [parent.style, parent.gutter, parent.columnNum]);
  const contentStyle = (0, import_react.useMemo)(() => {
    const {
      square: square2,
      gutter: gutter2
    } = parent;
    if (square2 && gutter2) {
      const gutterValue = (0, import_utils.addUnit)(gutter2);
      return __spreadProps(__spreadValues({}, props.contentStyle), {
        right: gutterValue,
        bottom: gutterValue,
        height: "auto"
      });
    }
    return props.contentStyle;
  }, [parent.gutter, parent.columnNum, props.contentStyle]);
  const renderIcon = () => {
    if (typeof props.icon === "string") {
      return /* @__PURE__ */ import_react.default.createElement(import_icon.default, {
        badge: props.badge,
        name: props.icon,
        size: parent.iconSize,
        className: (0, import_classnames.default)(bem("icon")),
        classPrefix: props.iconPrefix,
        color: props.iconColor
      });
    }
    if (/* @__PURE__ */ import_react.default.isValidElement(props.icon)) {
      return /* @__PURE__ */ import_react.default.createElement(import_badge.default, props.badge, props.icon);
    }
    return null;
  };
  const renderText = () => {
    if (/* @__PURE__ */ import_react.default.isValidElement(props.text)) {
      return props.text;
    }
    if (props.text) {
      return /* @__PURE__ */ import_react.default.createElement("span", {
        className: (0, import_classnames.default)(bem("text"))
      }, props.text);
    }
    return null;
  };
  const renderContent = () => {
    if (children) {
      return children;
    }
    return /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, renderIcon(), renderText());
  };
  const {
    center,
    border,
    square,
    gutter,
    reverse,
    direction
  } = parent;
  const classes = (0, import_classnames.default)(props.contentClassName, bem("content", [direction, {
    center,
    square,
    reverse,
    clickable: !!props.onClick,
    surround: border && gutter
  }]), {
    [import_constant.BORDER]: border
  });
  return /* @__PURE__ */ import_react.default.createElement("div", {
    className: (0, import_classnames.default)(className, bem({
      square
    })),
    style: rootStyle
  }, /* @__PURE__ */ import_react.default.createElement("div", {
    role: props.onClick ? "button" : void 0,
    className: classes,
    style: contentStyle,
    onClick: props.onClick
  }, renderContent()));
};
GridItem.defaultProps = {
  index: 0,
  parent: {}
};
var stdin_default = GridItem;
