var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  useTouch: () => useTouch
});
module.exports = __toCommonJS(stdin_exports);
var import_react = require("react");
const MIN_DISTANCE = 10;
const getDirection = (x, y) => {
  if (x > y && x > MIN_DISTANCE) {
    return "horizontal";
  }
  if (y > x && y > MIN_DISTANCE) {
    return "vertical";
  }
  return "";
};
function useTouch() {
  const startX = (0, import_react.useRef)(0);
  const startY = (0, import_react.useRef)(0);
  const deltaX = (0, import_react.useRef)(0);
  const deltaY = (0, import_react.useRef)(0);
  const offsetX = (0, import_react.useRef)(0);
  const offsetY = (0, import_react.useRef)(0);
  const direction = (0, import_react.useRef)("");
  const isTap = (0, import_react.useRef)(true);
  const isVertical = () => direction.current === "vertical";
  const isHorizontal = () => direction.current === "horizontal";
  const reset = () => {
    deltaX.current = 0;
    deltaY.current = 0;
    offsetX.current = 0;
    offsetY.current = 0;
    direction.current = "";
    isTap.current = true;
  };
  const start = (event) => {
    reset();
    startX.current = event.touches[0].clientX;
    startY.current = event.touches[0].clientY;
  };
  const move = (event) => {
    const touch = event.touches[0];
    deltaX.current = (touch.clientX < 0 ? 0 : touch.clientX) - startX.current;
    deltaY.current = touch.clientY - startY.current;
    offsetX.current = Math.abs(deltaX.current);
    offsetY.current = Math.abs(deltaY.current);
    const LOCK_DIRECTION_DISTANCE = 10;
    if (!direction.current || offsetX.current < LOCK_DIRECTION_DISTANCE && offsetY.current < LOCK_DIRECTION_DISTANCE) {
      direction.current = getDirection(offsetX.current, offsetY.current);
    }
    const TAP_OFFSET = 5;
    if (isTap.current && (offsetX.current > TAP_OFFSET || offsetY.current > TAP_OFFSET)) {
      isTap.current = false;
    }
  };
  return {
    move,
    start,
    reset,
    startX,
    startY,
    deltaX,
    deltaY,
    offsetX,
    offsetY,
    direction,
    isVertical,
    isHorizontal,
    isTap
  };
}
