var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_utils = require("./utils");
var import_useEventVisible = __toESM(require("./utils/useEventVisible"));
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const LazyloadImage = (props) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("lazyload-image", prefixCls);
  const _a = props, {
    className,
    type,
    style: incomingStyle,
    image,
    errorImage,
    loading,
    eventOptions,
    height,
    width,
    onLoaded
  } = _a, restProps = __objRest(_a, [
    "className",
    "type",
    "style",
    "image",
    "errorImage",
    "loading",
    "eventOptions",
    "height",
    "width",
    "onLoaded"
  ]);
  const [containerRef, visible] = (0, import_useEventVisible.default)(eventOptions);
  (0, import_react.useEffect)(() => {
    if (visible && containerRef.current) {
      const target = containerRef.current;
      const url = target.dataset.src || "";
      (0, import_utils.loadImage)(url).catch(() => {
        (0, import_utils.setImage)(target, errorImage);
        (0, import_utils.addCssClassName)(target, bem("error"));
      }).then((imagePath) => {
        (0, import_utils.setImage)(target, imagePath);
        (0, import_utils.addCssClassName)(target, bem("loaded"));
        target.setAttribute("lazy", "loaded");
        target.removeAttribute("data-src");
        onLoaded == null ? void 0 : onLoaded();
      });
    }
  }, [visible]);
  const style = __spreadProps(__spreadValues({}, incomingStyle), {
    height,
    width
  });
  return /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, type === "image" ? /* @__PURE__ */ (0, import_react.createElement)("img", __spreadProps(__spreadValues({}, restProps), {
    ref: containerRef,
    style,
    "data-src": image,
    src: loading || import_utils.DEFAULT_URL,
    className: (0, import_classnames.default)(bem(), className)
  })) : /* @__PURE__ */ (0, import_react.createElement)("div", __spreadProps(__spreadValues({}, restProps), {
    ref: containerRef,
    style,
    "data-src": image,
    className: (0, import_classnames.default)(bem(), className)
  }), props.children));
};
LazyloadImage.defaultProps = {
  loading: null,
  eventOptions: {
    listenEvents: import_utils.DEFAULT_EVENTS,
    scrollContainer: document.body,
    offset: 0,
    debounce: 300,
    throttle: 0
  },
  type: "image",
  errorImage: import_utils.DEFAULT_URL
};
var stdin_default = LazyloadImage;
