var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_icon = __toESM(require("../icon"));
var import_utils = require("../utils");
var import_constant = require("../utils/constant");
var import_use_height = __toESM(require("../hooks/use-height"));
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const NavBar = (props) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("nav-bar", prefixCls);
  const navBarRef = (0, import_react.useRef)();
  const height = (0, import_use_height.default)(navBarRef);
  const onClickLeft = (event) => {
    var _a;
    return (_a = props.onClickLeft) == null ? void 0 : _a.call(props, event);
  };
  const onClickRight = (event) => {
    var _a;
    return (_a = props.onClickRight) == null ? void 0 : _a.call(props, event);
  };
  const renderLeft = () => {
    return [props.leftArrow && /* @__PURE__ */ import_react.default.createElement(import_icon.default, {
      key: "icon",
      className: (0, import_classnames.default)(bem("arrow")),
      name: "arrow-left"
    }), props.leftArea && /* @__PURE__ */ import_react.default.createElement("span", {
      key: "left-area",
      className: (0, import_classnames.default)(bem("text"))
    }, props.leftArea)];
  };
  const renderRight = () => {
    return /* @__PURE__ */ import_react.default.createElement("span", {
      className: (0, import_classnames.default)(bem("text"))
    }, props.rightArea);
  };
  const renderNavBar = () => {
    const {
      title,
      fixed,
      border,
      zIndex
    } = props;
    const style = (0, import_utils.getZIndexStyle)(zIndex);
    const hasLeft = props.leftArrow || props.leftArea;
    const hasRight = props.rightArea;
    return /* @__PURE__ */ import_react.default.createElement("div", {
      ref: navBarRef,
      style,
      className: (0, import_classnames.default)(bem({
        fixed,
        "safe-area-inset-top": props.safeAreaInsetTop
      }), {
        [import_constant.BORDER_BOTTOM]: border
      })
    }, /* @__PURE__ */ import_react.default.createElement("div", {
      className: (0, import_classnames.default)(bem("content"))
    }, hasLeft && /* @__PURE__ */ import_react.default.createElement("div", {
      className: (0, import_classnames.default)(bem("left"), import_constant.HAPTICS_FEEDBACK),
      onClick: onClickLeft
    }, renderLeft()), /* @__PURE__ */ import_react.default.createElement("div", {
      className: (0, import_classnames.default)(bem("title"), "van-ellipsis")
    }, title), hasRight && /* @__PURE__ */ import_react.default.createElement("div", {
      className: (0, import_classnames.default)(bem("right"), import_constant.HAPTICS_FEEDBACK),
      onClick: onClickRight
    }, renderRight())));
  };
  const renderPlaceholder = () => /* @__PURE__ */ import_react.default.createElement("div", {
    className: (0, import_classnames.default)(bem("placeholder")),
    style: {
      height: height ? `${height}px` : void 0
    }
  }, renderNavBar());
  if (props.fixed && props.placeholder) {
    return renderPlaceholder();
  }
  return renderNavBar();
};
NavBar.defaultProps = {
  title: "",
  leftArea: "",
  rightArea: "",
  leftArrow: false,
  border: true,
  fixed: false,
  placeholder: false,
  zIndex: 1,
  safeAreaInsetTop: false
};
var stdin_default = NavBar;
