var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_utils = require("../utils");
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const Progress = (props) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("progress", prefixCls);
  const {
    inactive,
    color,
    trackColor,
    percentage,
    strokeWidth
  } = props;
  const background = (0, import_react.useMemo)(() => {
    return inactive ? void 0 : color;
  }, [inactive, color]);
  const renderPivot = () => {
    const {
      textColor,
      pivotText,
      pivotColor
    } = props;
    const text = pivotText != null ? pivotText : `${percentage}%`;
    if (props.showPivot && text) {
      const style = {
        color: textColor,
        left: `${+percentage}%`,
        transform: `translate(-${+percentage}%,-50%)`,
        background: pivotColor || background
      };
      return /* @__PURE__ */ import_react.default.createElement("span", {
        style,
        className: bem("pivot", {
          inactive: props.inactive
        })
      }, text);
    }
    return null;
  };
  const rootStyle = {
    background: trackColor,
    height: (0, import_utils.addUnit)(strokeWidth)
  };
  const portionStyle = {
    width: `${percentage}%`,
    background
  };
  return /* @__PURE__ */ import_react.default.createElement("div", {
    className: (0, import_classnames.default)(props.className, bem()),
    style: rootStyle
  }, /* @__PURE__ */ import_react.default.createElement("span", {
    className: (0, import_classnames.default)(bem("portion", {
      inactive: props.inactive
    })),
    style: portionStyle
  }), renderPivot());
};
Progress.defaultProps = {
  percentage: 0,
  strokeWidth: "4px",
  color: "#1989fa",
  trackColor: "#e5e5e5",
  pivotColor: "",
  textColor: "white",
  inactive: false,
  showPivot: true
};
var stdin_default = Progress;
