var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
var import_utils = require("../utils");
const RollingTextItem = ({
  direction,
  figureArr,
  isStart,
  height,
  duration,
  delay
}) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("rolling-text-item", prefixCls);
  const newFigureArr = (0, import_react.useMemo)(() => {
    return direction === "down" ? figureArr.slice().reverse() : figureArr;
  }, [direction, figureArr]);
  const translatePx = (0, import_react.useMemo)(() => {
    const totalHeight = height * (figureArr.length - 1);
    return `-${totalHeight}px`;
  }, [height, figureArr]);
  const itemStyle = (0, import_react.useMemo)(() => ({
    lineHeight: (0, import_utils.addUnit)(height)
  }), [height]);
  const rootStyle = (0, import_react.useMemo)(() => ({
    height: (0, import_utils.addUnit)(height),
    "--rc-translate": translatePx,
    "--rc-duration": `${duration}s`,
    "--rc-delay": `${delay}s`
  }), [duration, delay, translatePx]);
  return /* @__PURE__ */ import_react.default.createElement("div", {
    className: (0, import_classnames.default)(bem([direction])),
    style: rootStyle
  }, /* @__PURE__ */ import_react.default.createElement("div", {
    className: (0, import_classnames.default)(bem("box", {
      animate: isStart
    }))
  }, Array.isArray(newFigureArr) && newFigureArr.map((figure, index) => /* @__PURE__ */ import_react.default.createElement("div", {
    className: (0, import_classnames.default)(bem("item")),
    key: String(index),
    style: itemStyle
  }, figure))));
};
RollingTextItem.defaultProps = {
  duration: 2,
  direction: "down",
  height: 40
};
var stdin_default = RollingTextItem;
