var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_utils = require("../utils");
var import_constant = require("../utils/constant");
var import_use_height = __toESM(require("../hooks/use-height"));
var import_TabbarContext = __toESM(require("./TabbarContext"));
var import_use_merged_state = __toESM(require("../hooks/use-merged-state"));
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const Tabbar = (props) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("tabbar", prefixCls);
  const [current, setCurrent] = (0, import_use_merged_state.default)({
    value: props.value,
    defaultValue: props.defaultValue
  });
  const root = (0, import_react.useRef)();
  const height = (0, import_use_height.default)(root);
  const renderPlaceholder = (renderContent) => {
    return /* @__PURE__ */ import_react.default.createElement("div", {
      className: (0, import_classnames.default)(bem("placeholder")),
      style: {
        height
      }
    }, renderContent());
  };
  const enableSafeArea = () => {
    var _a;
    return (_a = props.safeAreaInsetBottom) != null ? _a : props.fixed;
  };
  const setActive = (active) => {
    var _a;
    if (active !== props.value) {
      (_a = props.onChange) == null ? void 0 : _a.call(props, active);
      setCurrent(active);
    }
  };
  const renderTabbar = () => {
    const {
      fixed,
      zIndex,
      border
    } = props;
    return /* @__PURE__ */ import_react.default.createElement(import_TabbarContext.default.Provider, {
      value: {
        parent: __spreadProps(__spreadValues({}, props), {
          value: current
        })
      }
    }, /* @__PURE__ */ import_react.default.createElement("div", {
      ref: root,
      style: __spreadValues(__spreadValues({}, props.style), (0, import_utils.getZIndexStyle)(zIndex)),
      className: (0, import_classnames.default)(props.className, bem({
        fixed
      }), {
        [import_constant.BORDER_TOP_BOTTOM]: border,
        "rc-safe-area-bottom": enableSafeArea()
      })
    }, import_react.default.Children.toArray(props.children).filter(Boolean).map((child, index) => /* @__PURE__ */ import_react.default.cloneElement(child, {
      setActive,
      index
    }))));
  };
  if (props.fixed && props.placeholder) {
    return renderPlaceholder(renderTabbar);
  }
  return renderTabbar();
};
Tabbar.defaultProps = {
  fixed: true,
  border: true,
  defaultValue: 0
};
var stdin_default = Tabbar;
