var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_TabsContext = __toESM(require("./TabsContext"));
var import_hooks = require("../hooks");
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const TabPane = /* @__PURE__ */ (0, import_react.forwardRef)((props, ref) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("tab", prefixCls);
  const parent = (0, import_react.useContext)(import_TabsContext.default);
  const [inited, setInited] = (0, import_react.useState)(false);
  const {
    animated,
    swipeable,
    scrollspy,
    lazyRender
  } = parent.props;
  const {
    index
  } = props;
  const getName = () => {
    var _a;
    return (_a = props.name) != null ? _a : index;
  };
  const init = () => {
    setInited(true);
  };
  const isActive = (0, import_react.useMemo)(() => {
    const active = getName() === parent.currentName;
    if (active && !inited) {
      init();
    }
    return active;
  }, [inited, parent.currentName]);
  (0, import_hooks.useUpdateEffect)(() => {
    parent.setLine();
    parent.scrollIntoView();
  }, [props.title]);
  const show = scrollspy || isActive;
  if (animated || swipeable) {
    return /* @__PURE__ */ import_react.default.createElement("div", {
      className: (0, import_classnames.default)(bem("pane"))
    }, props.children);
  }
  const shouldRender = inited || scrollspy || !lazyRender;
  const Content = shouldRender ? props.children : null;
  return /* @__PURE__ */ import_react.default.createElement("div", {
    ref,
    style: {
      display: show ? "block" : "none"
    },
    role: "tabpanel",
    className: (0, import_classnames.default)(bem("pane"))
  }, Content);
});
TabPane.defaultProps = {
  showZeroBadge: true
};
var stdin_default = TabPane;
