var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_react_transition_group = require("react-transition-group");
var import_icon = __toESM(require("../icon"));
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const Tag = (props) => {
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("tag", prefixCls);
  const nodeRef = (0, import_react.useRef)(null);
  const {
    visible,
    plain,
    textColor,
    color,
    type,
    mark,
    round,
    size,
    closeable,
    onClick,
    onClose,
    children
  } = props;
  const handleClose = (event) => {
    event.stopPropagation();
    onClose == null ? void 0 : onClose(event);
  };
  const getStyle = (0, import_react.useMemo)(() => {
    if (plain) {
      return {
        color: textColor || color,
        borderColor: color
      };
    }
    return {
      color: textColor,
      background: color
    };
  }, [textColor, color, plain]);
  const renderTag = () => {
    const classes = {
      mark,
      plain,
      round
    };
    if (size) {
      classes[size] = size;
    }
    const CloseIcon = closeable && /* @__PURE__ */ import_react.default.createElement(import_icon.default, {
      name: "cross",
      className: (0, import_classnames.default)(bem("close")),
      onClick: handleClose
    });
    return /* @__PURE__ */ import_react.default.createElement("span", {
      ref: nodeRef,
      style: __spreadValues(__spreadValues({}, getStyle), props.style),
      className: (0, import_classnames.default)(props.className, bem([classes, type])),
      onClick
    }, children, CloseIcon);
  };
  return /* @__PURE__ */ import_react.default.createElement(import_react_transition_group.CSSTransition, {
    nodeRef,
    classNames: "rc-fade",
    in: visible,
    timeout: 300,
    unmountOnExit: true
  }, renderTag());
};
Tag.defaultProps = {
  visible: true,
  type: "default"
};
var stdin_default = Tag;
