var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var stdin_exports = {};
__export(stdin_exports, {
  default: () => stdin_default
});
module.exports = __toCommonJS(stdin_exports);
var import_react = __toESM(require("react"));
var import_classnames = __toESM(require("classnames"));
var import_icon = __toESM(require("../icon"));
var import_popup = __toESM(require("../popup"));
var import_loading = __toESM(require("../loading"));
var import_lock_click = require("./lock-click");
var import_utils = require("../utils");
var import_ConfigProviderContext = __toESM(require("../config-provider/ConfigProviderContext"));
const Toast = (props) => {
  let clickable = false;
  const {
    prefixCls,
    createNamespace
  } = (0, import_react.useContext)(import_ConfigProviderContext.default);
  const [bem] = createNamespace("toast", prefixCls);
  const toggleClickable = () => {
    const newValue = props.visible && props.forbidClick;
    if (clickable !== newValue) {
      clickable = newValue;
      (0, import_lock_click.lockClick)(clickable);
    }
    if (!props.visible) {
      (0, import_lock_click.lockClick)(false);
    }
  };
  const handleClick = () => {
    var _a;
    if (props.closeOnClick) {
      (_a = props.onClose) == null ? void 0 : _a.call(props);
    }
  };
  (0, import_react.useEffect)(() => {
    toggleClickable();
  }, [props.visible, props.forbidClick]);
  const renderIcon = () => {
    const {
      icon,
      type,
      iconPrefix,
      iconSize,
      loadingType
    } = props;
    const hasIcon = icon || type === "success" || type === "fail";
    if (hasIcon) {
      return typeof icon === "string" ? /* @__PURE__ */ import_react.default.createElement(import_icon.default, {
        name: icon || (type === "fail" ? "cross" : type),
        size: iconSize,
        className: (0, import_classnames.default)(bem("icon")),
        classPrefix: iconPrefix
      }) : icon;
    }
    if (type === "loading") {
      return /* @__PURE__ */ import_react.default.createElement(import_loading.default, {
        className: (0, import_classnames.default)(bem("loading")),
        type: loadingType
      });
    }
    return null;
  };
  const renderMessage = () => {
    const {
      message
    } = props;
    if ((0, import_utils.isDef)(message) && message !== "") {
      return /* @__PURE__ */ import_react.default.createElement("div", {
        className: (0, import_classnames.default)(bem("info"))
      }, message);
    }
    return null;
  };
  return /* @__PURE__ */ import_react.default.createElement(import_popup.default, {
    className: (0, import_classnames.default)([bem([props.position, {
      [props.type]: !props.icon
    }]), props.className]),
    visible: props.visible,
    overlay: props.overlay,
    transition: props.transition,
    overlayClass: props.overlayClass,
    overlayStyle: props.overlayStyle,
    closeOnClickOverlay: props.closeOnClickOverlay,
    lockScroll: false,
    onClick: handleClick,
    onClose: props.onClose,
    onClosed: props.onClosed,
    onOpened: props.onOpened,
    teleport: props.teleport
  }, renderIcon(), renderMessage());
};
Toast.defaultProps = {
  type: "info",
  duration: 2e3,
  position: "middle",
  transition: "rc-fade",
  loadingType: "circular",
  overlay: false
};
var stdin_default = Toast;
